﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.Misc;
using Infragistics.Win.UltraWinGrid;

namespace UltraGridWithButtonCreationFilter
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            ultraGrid1.CreationFilter = new CreatingButtonUIElement();
        }
    }

    public class CreatingButtonUIElement : IUIElementCreationFilter
    {
        
        public void AfterCreateChildElements(UIElement parent)
        {
            HeaderUIElement El = parent as HeaderUIElement;
            if (El != null)
            {
                ButtonUIElement newButton = new ButtonUIElement(El);
                newButton.Text = "X";
                newButton.Rect = new Rectangle(El.Rect.X +El.Rect.Width - 20, El.Rect.Y, 18, 18);
                El.ChildElements.Add(newButton);
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }

    }

}
